
var toolbox = {};
$(function(){

    var toolboxShelf = $('#editor div.toolbox');

    /**
     * Collection of all the tools in our toolbox.
     * @type {Object.< String, Tool >}
     */
    var registeredTools = {};

    /**
     * The name of the currently selected tool.
     * @type {String}
     */
    var activeToolName;

    /**
     * Triggers an event for the active tool to handle.
     *
     * @param {jQuery.Event} event The event to trigger.
     */
    function trigger( event ){
        $(registeredTools[ activeToolName ]).trigger( event );
    }
    toolbox.trigger = trigger;

    /**
     * Binds a callback to a toolbox event.
     *
     * @param {String}   eventName The name of the event to bind to.
     * @param {Function} callback  The function to call when the event occurs.
     */
    function bind( eventName, callback ){
        $(toolbox).bind( 'sculptly_'+eventName, callback );
    }
    toolbox.bind = bind;

    /**
     * Registers a new tool with the toolbox.
     *
     * @param {Tool} tool The tool to register.
     */
    function register( tool ){
        registeredTools[ tool.getName() ] = tool;

        // TODO: Add displaying of the tool's icon in the toolbox shelf.
    }
    toolbox.register = register;

});

